package Aufgaben.A03

import Aufgaben.Position
import Aufgaben.ADTListe

// now follows some magic ... see Objective-C Categories
// or Groovy Categories ... otherwise just ignore it ;-)
class ADTListeErweiterung {
    static ADTListe subList(ADTListe liste, Position p, int len) {
        if (p==Position.NULL) {
            System.err.println("Startposition ist ungltig")
            return null
        }
        if (len > liste.size()) {
            System.err.println("Lnge ist ungltig")
            return null
        }
        ADTListe ret = new ADTListe()
        int x = 0
        while (p.wert+x<=len) {
            ret.insert(liste.retrieve(new Position(p.wert+x)), new Position(x-1))
            x++
        }
        return ret
    }
}
// ------------------------ read on :)

// new list 
ADTListe l = new ADTListe()
// fill it with 10 items
(1..10).each({ k -> l.insert(k,new Position(-2+k))})
assert [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]==l.content[0..9], "Inhalt nicht korrekt"

use (ADTListeErweiterung) {
    // now subList method is available to us
    assert [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]==l.subList(new Position(0),9).content[0..9], "subList arbeitet nicht richtig"
}

println "Alles Ok"