package Aufgaben.A03

import Aufgaben.ADTStack

// now follows some magic ... see Objective-C Categories
// or Groovy Categories ... otherwise just ignore it ;-)
class ADTStackErweiterung {
    static ADTStack reverse(ADTStack stack) {
        //println stack.elements
        ADTStack intermed = new ADTStack()
        ADTStack ret = new ADTStack()
        while (!stack.empty()) {
            intermed.push(stack.pop())
            if (stack.top()==" " || stack.empty()) {
                while (!intermed.empty()) {
                    ret.push(intermed.pop())
                }
            }
            if (stack.top()==" ") ret.push(stack.pop())
            // Comment in the following for debugging
            /*println "st: "+stack.elements
            println "im: "+intermed.elements
            println "rt: "+ret.elements
            println "-"*100*/
        }
        return ret
    }
}
// ------------------------ read on :)

// new list 
ADTStack stack = new ADTStack()
assert stack.size()==0, "Stack ist nicht leer"
assert stack.empty(), "Stack ist nicht leer"

// fill it with 10 items
(1..10).each({v -> stack.push(v)})
assert [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]==stack.elements[0..9], "Inhalt nicht korrekt"
10.times( { v -> 
    assert stack.top()==10-v, "Top ist nicht korrekt"
    assert stack.pop()==10-v, "Top ist nicht korrekt"
})
assert stack.empty(), "Stack ist nicht leer"

use (ADTStackErweiterung) {
    "was it a cat i saw".each({stack.push(it)})
    def rev = stack.reverse()
    String revS = ""
    while (!rev.empty()) revS += rev.pop()
    assert "saw ti a tac i was"==revS, "reverse tut nicht, was es soll"
}

println "Alles Ok"