package Aufgaben;

import Aufgaben.Position as Position

class ADTListe {
    Object[] content
    int last
    static final int MAXLENGTH = 2**10
    ADTListe() {
        content = new Object[MAXLENGTH]
        last = -1
    }
    def first() {
        if (last>-1) return new Position(0)
        return Position.NULL
    }
    def end() {
        if (last>-1) return new Position(last)
        return Position.NULL
    }
    def next(Position p) {
        // korrekter als das Skript, das hlt sich nichtmal an seine eigenen Definitionen
        if (p.wert<0 || p.wert > last) {
            println "Position existiert nicht"
            return null;
        }
        if (p.wert==last)
            return Position.NULL
        return content[p.wert+1]
    }
    def retrieve(Position p) {
        if (p.wert<0 || p.wert > last) {
            println "Position existiert nicht"
            return null;
        }
        return content[p.wert]
    }
    def insert(Object x, Position p) {
        if (last >= MAXLENGTH) {
            System.err.println "Liste ist voll"
            return null
        } else if (p.wert < -1 || p.wert > last) {
            System.err.println "Position ist ungltig"
            return null
        }
        for (int curr = last; curr > p.wert; curr--) {
            content[curr+1]=content[curr]
        }
        content[p.wert+1]=x
        last++
    }
    def delete(p) {
        if (p.wert < -1 || p.wert > last) {
            System.err.println "Position ist ungltig"
            return null
        }
        Object x = content[p.wert]
        last--
        for (int curr=p.wert; curr<last; curr++) {
            content[curr] = content[curr+1]
        }
        return x
    }
    def size() {
        // Methode, die es strflicherweise noch nicht gab
        last==-1?0:last
    }
}