package Aufgaben;

import Aufgaben.DNodePosition as Position
import Aufgaben.DNode as DNode

class ADTDNodeListe {
    Object[] content
    DNode firstNode
    ADTDNodeListe() {
        firstNode = new DNode()
        firstNode.prev = firstNode
        firstNode.next = firstNode
    }
    def Position first() {
        return new Position(firstNode)
    }
    def end() {
        DNode curr = firstNode
        if (curr.element==null) return Position.NULL
        return new Position(firstNode.prev)
    }
    def next(Position p) {
        if (p.wert.next!=null) return new Position(p.wert.next)
        return Position.NULL
    }
    def retrieve(Position p) {
        return p.wert.element
    }
    def insert(Object x, Position p) {
        DNode node = new DNode()
        node.element = x
        if (p.wert?.element) {
            node.next = p.wert.next
            p.wert.next = node
            node.prev = p.wert
            node.next.prev = node
        } else { // insert as first
	    firstNode.prev.next = node
	    node.prev = firstNode.prev
	    firstNode.prev = node
	    node.next = firstNode
	    firstNode = node
        }
    }
    def delete(Position p) {
        DNode q = p.wert
        q.prev.next = q.next
        q.next.prev = q.prev
        return q.element
    }
    def size() {
        // Methode, die es strflicherweise noch nicht gab
        DNode q = firstNode
        int i = 0
        if (q.next!=firstNode) {
            i++
            while (q.next!=firstNode.prev) {
                q=q.next
                i++
            }
        }
        return i
    }
    Object[] elements() {
	Object[] ret = new Object[size()]
	DNode q = firstNode
        int i = 0
        if (q.next!=firstNode) {
            ret[i]=q.element
            i++
            while (q.next!=firstNode.prev) {
                q=q.next
		ret[i]=q.element
                i++
            }
        }
        return ret
    }
}