package Aufgaben;

import Aufgaben.SNodePosition as SNodePosition
import Aufgaben.SNode as SNode

class ADTSNodeListe {
    SNode firstNode
    ADTSNodeListe() {
        firstNode = null
    }
    def SNodePosition first() {
        return new SNodePosition(firstNode)
    }
    def end() {
        SNode curr = firstNode
        if (curr==null) return SNodePosition.NULL
        while (curr.next!=null) {
            curr=curr.next
        }
        return new SNodePosition(curr)
    }
    def next(SNodePosition p) {
        if (p.wert.next!=null) return new SNodePosition(p.wert.next)
        return SNodePosition.NULL
    }
    def retrieve(SNodePosition p) {
        return p.wert.element
    }
    def insert(Object x, SNodePosition p) {
        SNode node = new SNode(x)
        node.element = x
        if (p!=SNodePosition.NULL) {
            node.next = p.wert.next
            p.wert.next = node
        } else { // insert as first
            node.next = firstNode
            firstNode = node
        }
    }
    def delete(SNodePosition p) {
        SNode q = firstNode
        if (q == null) {
            System.err.println "Liste ist leer"
            return null
        }
        while (q.next!=p.wert && q.next!=null) {
            q=q.next
        }
        if (q.next==null) {
            System.err.println "Ungltige SNodePosition"
            return null
        }
        q.next=q.next.next
        return p.wert.element
    }
    def size() {
        // Methode, die es strflicherweise noch nicht gab
        SNode q = firstNode
        int i = 0
        if (q!=null) {
            i++
            while (q.next!=null) {
                q=q.next
                i++
            }
        }
        return i
    }
    Object[] elements() {
	Object[] ret = new Object[size()]
	SNode q = firstNode
        int i = 0
        if (q!=null) {
            ret[i]=q.element
            i++
            while (q.next!=null) {
                q=q.next
		ret[i]=q.element
                i++
            }
        }
        return ret
    }
}